 INCLUDE reg_51.pdf
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;		PORT DECLERATION
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ENROLL	EQU	P1.3
DELETE	EQU	P1.4
IDENTIFY	EQU	P1.5

SUCESS	EQU	P1.1
FAIL		EQU	P1.2

IDENTIFY_KEY	EQU	P3.3

RED	EQU	P1.6
GREEN	EQU	P1.7

RELAY	EQU	P1.0
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

CSEG     AT      0        ; RESET VECTOR
;---------==========----------==========---------=========---------
;              PROCESSOR INTERRUPT AND RESET VECTORS
;---------==========----------==========---------=========---------
 
	ORG     00H    		; Reset
	JMP     MAIN

;---------==========----------==========---------=========---------
;  Main routine. Program execution starts here.
;---------==========----------==========---------=========---------
MAIN:	

   	MOV SP,#60h
		CLR RELAY			;Switch off relay
	
 		CLR IDENTIFY
 		CLR ENROLL
 		CLR DELETE
 	
 		SETB RED
 		SETB GREEN
		SETB IDENTIFY_KEY 	
TOP:	JB IDENTIFY_KEY,TOP	;wait for button press
 		CALL DELAY
 		JNB IDENTIFY_KEY,$
 	
 		SETB IDENTIFY			;start identification
 		CALL DELAY
 		CLR IDENTIFY
 		SETB SUCESS
 		SETB FAIL
 		
HERE:	JNB SUCESS,OK			;wait for output from sensor
		JB FAIL,HERE
		CLR RED					;Failed
		SETB GREEN
		SETB IDENTIFY_KEY
 		JB IDENTIFY_KEY,$
 		CALL DELAY
 		JNB IDENTIFY_KEY,$
 		SETB RED
 		SETB GREEN
		AJMP TOP
		
OK:	CLR GREEN				;sucess
		SETB RED
		CPL RELAY				;complement relay
		SETB IDENTIFY_KEY
 		JB IDENTIFY_KEY,$
 		CALL DELAY
 		JNB IDENTIFY_KEY,$
 		SETB RED
 		SETB GREEN		
 		AJMP TOP
;**********************************************************
DELAY:
	MOV R1,#0FFH
REP2:	MOV R2,#0FFH
REP1:	NOP
	DJNZ R2,REP1
	DJNZ R1,REP2
	RET
	
	END	
  
 


